
*---
FUNCTION WaitWind(tcMess, tnTopOfForm, tnFontSize)
IF EMPTY(tcMess)
	RETU
ENDIF

IF !(TYPE('oFrmWait')='O' AND !ISNULL(oFrmWait))
	WAIT WINDOW tcMess NOWAIT
	RETU
ENDIF

SET CURSOR OFF
*INKEY(0.01)
wait wind [] at 0,0 timeout 0.01
*  ^^^.    ,        -
*-      (   MainMenu.mpr).

WITH oFrmWait
	IF !EMPTY(tcMess)
		.nLabel1Top    = .Label1.Top
		.nLabel1Height = .Label1.Height
		WITH .Label1
			IF CHR(13)$tcMess
				*    2 
				.Top		= .Parent.Height/2 - .Height	&&  Label1 
				.WordWrap	= .T.							&&    
				.Height		= 2 * .Height					&&   Label1
			ENDIF
			.Caption = tcMess
			IF !EMPTY(tnFontSize) AND TYPE('tnFontSize')='N'
				.FontSize = tnFontSize
			ENDIF
		ENDWITH
	ENDIF
	IF !EMPTY(tnTopOfForm) AND TYPE('tnTopOfForm')='N'
		*   
		.Top = tnTopOfForm
	ENDIF
	.AlwaysOnTop = .T.
	.AlwaysOnTop = .F.
	.Refresh()				&&         .Caption
ENDWITH
oForm1.AlwaysOnTop = .F.
INKEY(0.1)					&&    
SET CURSOR ON
RETU



*---
FUNCTION WaitClear()
IF !(TYPE('oFrmWait')='O' AND !ISNULL(oFrmWait))
	WAIT CLEAR
	RETU
ENDIF
*..   MainForm     page1.grig.when()
IF VARTYPE(oForm1) = 'O'
	IF VARTYPE(oFrmWait) = 'O'
		WITH oFrmWait
			.Label1.Caption  = [    ""...]
			.Label1.FontSize = .nFontSize
			.Label1.Height   = .nLabel1Height
			.Label1.WordWrap = .F.
			*   Label1.Top:
			.Label1.Top      = IIF(.nLabel1Top=0, .Label1.Top, .nLabel1Top)
			* .nLabel1Top=0  ^^^    DO FORM WaitWind NAME oFrmWait WITH ...
			.AlwaysOnTop= .F.
			.Top		= .nTop
*			.Refresh()				&&         .Caption
		ENDWITH
		oForm1.AlwaysOnTop = .T.
		oForm1.AlwaysOnTop = .F.
		*   ^^^?      oForm1 
		*browse (1- .    ; 2- '  '
	ENDIF
ENDIF
RETU

*---
FUNCTION WaitClear2(oF2, oF3)
IF !(TYPE('oFrmWait')='O' AND !ISNULL(oFrmWait))
	RETU
ENDIF
*..   MainForm     page1.grig.when()
IF VARTYPE(oForm1) = 'O'
	IF VARTYPE(oFrmWait) = 'O'
		WITH oFrmWait
			.Label1.Caption  = [    ""...]
			.Label1.FontSize = .nFontSize
			.Label1.Height   = .nLabel1Height
			.Label1.WordWrap = .F.
			*   Label1.Top:
			.Label1.Top      = IIF(.nLabel1Top=0, .Label1.Top, .nLabel1Top)
			* .nLabel1Top=0  ^^^    DO FORM WaitWind NAME oFrmWait WITH ...
			.AlwaysOnTop= .F.
			.Top		= .nTop
			.Refresh()				&&         .Caption
		ENDWITH
		oForm1.AlwaysOnTop = .T.
		oForm1.AlwaysOnTop = .F.
		oF2.AlwaysOnTop = .T.
		oF2.AlwaysOnTop = .F.
		*   ^^^?      oForm1 
		*browse (1- .    ; 2- '  '
		IF TYPE('oF3')='O' AND !ISNULL(oF3)
			oF3.AlwaysOnTop = .T.
			oF3.AlwaysOnTop = .F.
		ENDIF
	ENDIF
ENDIF
RETU


*---
FUNCTION AddQuotMarks(tcPath)
RETURN IIF([ ]$tcPath, ["]+tcPath+["], tcPath)


*---
FUNCTION IsFileShared
LPARAMETERS tcFileWithPath, tlDelete, tlForceExt
* ,    -     .T./.F.
*:
* tcFileName	-    (, , )
* tlDelete		-   ,     
* tlForceExt	-      
*				  (, xx.prg, xx.fxp  yy.dbf, yy.cdx)
LOCAL llRet, lcFileWithPath, lcPath, lcFile, lnHhandle, temparray[1]
llRet = .T.		&& ,  file shared
lcFileWithPath = tcFileWithPath

IF AT('\', lcFileWithPath) > 0
	lcFile = SUBSTR(lcFileWithPath,    AT('\', lcFileWithPath, OCCURS('\',lcFileWithPath))+1)
	lcPath = SUBSTR(lcFileWithPath, 1, AT('\', lcFileWithPath, OCCURS('\',lcFileWithPath)))
ELSE
	lcFile = lcFileWithPath
	lcPath = ''
ENDIF

*IF EMPTY( SYS(2000, lcFileWithPath) )
IF ADIR(temparray, lcFileWithPath, 'RHS')=0		&&   Hidden files
	*  
	llRet = .F.				&& file  shared
ELSE
	BEGIN TRANSACTION
		lnHhandle  = FOPEN(lcFileWithPath, 12)
		IF lnHhandle > 0
			*    lcFileWithPath    ReadOnly
			llRet = .F.		&& file  shared
			FCLOSE(lnHhandle)
			IF tlDelete
				=CleanAttrib( lcPath, lcFile, "HS")
				*DEBUGOUT lcFileWithPath + [  , ]
				IF tlForceExt
					ERASE FORCEEXT(lcFileWithPath, '*')
				ELSE
					ERASE (lcFileWithPath)
				ENDIF
			ENDIF
		ELSE
			*DEBUGOUT lcFileWithPath + [   ReadOnly]
		ENDIF
	END TRANSACTION
ENDIF
RETURN llRet


*---
FUNCTION CleanAttrib(dirT, maskaT, attrT)
dirT = IIF(EMPTY(dirT), dirT, ADDBS(dirT))
DIME temparray(1,1)
temparray(1,1)=0
IF TYPE('attrT') = 'C'
	=ADIR(temparray, dirT + maskaT, attrT)
	*^^^3- , . "H",     hidden-.
	*     .
ELSE
	=ADIR(temparray, dirT + maskaT )
ENDIF

LOCAL fa0, fa, FileName, aa, i

aa=IIF(ALEN(temparray,2)=1, 0, ALEN(temparray,1) )
*     5   .  . ,
* .=1 ,     ,  =0.

#DEFINE FILE_ATTRIBUTE_READONLY 	0x01
#DEFINE FILE_ATTRIBUTE_HIDDEN		0x02
#DEFINE FILE_ATTRIBUTE_SYSTEM		0x04
DECLARE Integer GetFileAttributes IN win32api string @
DECLARE Integer SetFileAttributes IN win32api string @, Integer
FOR i=1 TO aa
	FileName = dirT + temparray(i,1)	&& AddQuotMarks()  
	STORE GetFileAttributes(@FileName) TO fa, fa0
	fa = bitand(fa, bitnot(FILE_ATTRIBUTE_READONLY))
	fa = bitand(fa, bitnot(FILE_ATTRIBUTE_HIDDEN))
	fa = bitand(fa, bitnot(FILE_ATTRIBUTE_SYSTEM))
	IF fa<>fa0
		SetFileAttributes(@FileName, fa)
	ENDIF
ENDFOR
RETURN


*---
FUNC GetIniDir
*    applic.ini	(  .EXE  )
LOCAL lcRunDir
* ,    :
lcRunDir = GetAppDir()		&& .  funcv
*.     .EXE  .INI -.    lcRunDir - ,  .
*   main.prg  IDE  lcRunDir = "E:\USERS\VFP_OK\PROGS\",  .INI -
*     ,    "E:\USERS\VFP_OK\" :
lcRunDir = IIF('.EXE'$SYS(16,0), lcRunDir, STRTRAN( UPPER(lcRunDir), 'PROGS\', '') )
RETURN lcRunDir


*---
FUNC GetAppDir
*==============================================================================
* Function:			GetAppDir
* Purpose:			Returns the directory the application was started in
* Author:			Doug Hennig, modified from a routine published by Rick
*						Strahl
* Copyright:		(c) 2001 Stonefield Systems Group Inc.
* Last revision:	02/08/2001
* Parameters:		tcProgram - the program to get the directory from
*						(optional: if it isn't specified, the top program is
*						used)
* Returns:			the directory with trailing backslash
* Environment in:	none
* Environment out:	none
*==============================================================================

*:   _vfp.ServerName ( Application.ServerName)  
*     ?   02.08.2002 .
lparameters tcProgram
local lcProgram, ;
	lcPath, ;
	lnBytes, ;
	lcFileName
lcProgram = iif(vartype(tcProgram) = 'C' and not empty(tcProgram), tcProgram, ;
	sys(16, 0))

do case

* In-process DLL server or Active Document.

	case atc('.VFD', lcProgram) > 0 or Application.StartMode = 3
		lcPath = home()

* Out-of-process EXE server.

	case Application.StartMode = 2
		#define MAX_PATH 260
		declare integer GetModuleFileName in Win32API ;
			integer hModule, string @cFileName, integer @nSize
		lnBytes    = MAX_PATH
		lcFileName = space(MAX_PATH)
		GetModuleFileName(0, @lcFilename, @lnBytes)
		lcFileName = left(lcFileName, at(chr(0), lcFilename) - 1)
		lcPath     = justpath(lcFileName)

* Standalone EXE or VFP development.

	otherwise
		lcPath = justpath(lcProgram)
		if atc('PROCEDURE', lcPath) > 0
			lcPath = substr(lcPath, rat(':', lcPath) - 1)
		endif atc('PROCEDURE', lcPath) > 0
endcase
return addbs(upper(lcPath))


*---
FUNC GetIniDir
*    applic.ini	(  .EXE  )
LOCAL lcRunDir
* ,    :
lcRunDir = GetAppDir()		&& .  funcv
*.     .EXE  .INI -.    lcRunDir - ,  .
*   main.prg  IDE  lcRunDir = "E:\USERS\VFP_OK\PROGS\",  .INI -
*     ,    "E:\USERS\VFP_OK\" :
lcRunDir = IIF('.EXE'$SYS(16,0), lcRunDir, STRTRAN( UPPER(lcRunDir), 'PROGS\', '') )
RETURN lcRunDir

*---
FUNC PathToData(tcPath)
LOCAL olReg, lcINIValue, lcSection, lcEntry, lcINIFile
olReg = NEWOBJECT('oldinireg', 'registry')
lcSection  = 'data'
lcEntry    = 'Directory'
lcINIFile  = GetIniDir() + 'applic.ini'
olReg.GetINIEntry(@lcINIValue, lcSection, lcEntry, lcINIFile)
IF TYPE('tcPath') <> 'L'
	*   ,     :
	tcPath = UPPER(lcINIValue)
ENDIF
RETURN UPPER(lcINIValue)
*:         ,  1 :
* RETURN STRTRAN( UPPER(DBF('MAINV')), 'DATA\MAINV.DBF', 'DATA\')
*,        .



*---
FUNCTION ValidPrikaz
*      , ,  
LPARAMETERS toText1
LOCAL lcValue, lnPosition

IF toText1.ReadOnly = .T.	&&       
	RETURN
ENDIF

*           :
lcValue = CHRTRAN(STRTRAN(LOWER(ALLTRIM(toText1.Value)), [], []), ['"-.,=], [])
*      .  ,    .

*,           .
* 2-3       ,   .
*        . :
IF OCCURS([ ], lcValue) > 0
	lnPosition = AT([ ], lcValue, OCCURS([ ], lcValue) )	&&   
	IF EMPTY( CHRTRAN(SUBSTR(lcValue, lnPosition+1), [0123456789.], []) )
		*   => :
		lcValue = SUBSTR(lcValue, 1, lnPosition)
	ENDIF
	*   :
	lcValue = CHRTRAN(lcValue, [ ], [])
ENDIF
toText1.Value = lcValue
RETURN

